#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <conio.h>
#include <stdlib.h>
#include <cbm.h>

// Kerberos cartridge registers
#include "regs.h"

// Kerberos RAM extension
uint8_t* g_ram = (uint8_t*) 0xdf00;

extern uint8_t _CART128_LOAD__;
#define cart128Load (&_CART128_LOAD__)

extern uint8_t cart128Start;
#define cart128StartPtr (&cart128Start)

extern uint8_t cart128End;
#define cart128EndPtr (&cart128End)

// map a 256 bytes page of the 128 kb Kerberos SRAM to $df00-$dfff
void ramSetBank(uint16_t bank)
{
	// A16
	uint8_t control = 0;
	if (bank & 256) control |= ADDRESS_EXTENSION2_RAM_A16;
	ADDRESS_EXTENSION2 = control;
	
	// A15..A8
	RAM_ADDRESS_EXTENSION = bank & 0xff;
}

int main(void)
{
	// CC65 bug? cart128Start doesn't work
	uint8_t* start = (uint8_t*) 0x8000;
	uint16_t size = ((uint16_t) cart128EndPtr) - ((uint16_t) start);
	uint16_t i;
	
	cputs("starting C128 test program...");

	// copy 128 catridge code to RAM at $8000
	for (i = 0; i < size; i++) {
		uint16_t target = ((uint16_t) start) + i;
		if ((target & 0xff) == 0) {
			ramSetBank(target >> 8);
		}
		g_ram[target & 0xff] = cart128Load[i];
	}
	
	// CPLD generated reset for starting C128, with RAM as ROM enabled
	CART_CONFIG = CART_CONFIG_RAM_AS_ROM_ON;
	CART_CONTROL = CART_CONTROL_GAME_HIGH | CART_CONTROL_EXROM_HIGH | CART_CONTROL_RESET_GENERATE;
	
	return 0;
}
